SystemOrganization addCategory: #'ICU-NativeBoost-Core'!

Object subclass: #ICUNativeBoost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 10:27'!
getDefaultTimeZone
	"self getDefaultTimeZone"
	
	| buffer1 buffer2 length |
	
	buffer1 := ByteArray new: 200.
	buffer2 := ICUErrorCodeNB new.
	
	length := self getDefaultTimeZone: buffer1 with: buffer1 size / 2 with: buffer2. 
	
	^TwoByteString fromByteArray: buffer1 charSize: length! !

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/17/2012 09:29'!
getDefaultTimeZone: aResultBuffer with: aResultCapacity with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int ucal_getDefaultTimeZone_48( void* aResultBuffer, int aResultCapacity, ICUErrorCodeNB* anErrorCode ) ) module: self inModule 
	
! !

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/12/2012 17:28'!
getEnv:  aName
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ NBFFICallout cdecl: #( String  getenv( String aName) ) module: NativeBoost CLibrary
	
! !

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/12/2012 21:43'!
inModule

	^ NativeBoost forCurrentPlatform loadModule: 'libicui18n.dylib'! !

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/12/2012 21:36'!
ucModule

	^ NativeBoost forCurrentPlatform loadModule: 'libicuuc.dylib'! !

NBExternalHandle variableByteSubclass: #ICUEnumerationNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUEnumerationNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:43'!
byteStringCollection: anEnumAddress

	^ Array streamContents: [ :stream |
		| status result |
		status := ICUErrorCodeNB new.
		[ result := self primNext: anEnumAddress with: status. status check. result isNil ]
			whileFalse: [ stream nextPut: result readString ].
		self primClose: anEnumAddress ]! !

!ICUEnumerationNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:39'!
nbLibraryNameOrHandle

	^'libicui18n.dylib'! !

!ICUEnumerationNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:42'!
primClose: aHandle
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void uenum_close_48( void* aHandle) )! !

!ICUEnumerationNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:38'!
primNext: aHandle with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( char* uenum_next_48(void* aHandle, nil, ICUErrorCodeNB* anErrorCode ) )! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/13/2012 21:53'!
close

	self primClose ! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/17/2012 09:35'!
nbLibraryNameOrHandle

	^'libicuuc.dylib'! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/17/2012 09:58'!
next

	| value status resultLength |

	value := self primNext: (status := ICUErrorCodeNB new).
	^ value! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:42'!
primClose
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void uenum_close_48( self) )! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 11:36'!
primNext: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( char* uenum_next_48(void* self, nil, ICUErrorCodeNB* anErrorCode ) )! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/17/2012 10:05'!
primNext: aHandle with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( char* uenum_next_48(ICUEnumerationNB* aHandle, nil, ICUErrorCodeNB* anErrorCode ) )! !

NBExternalStructure variableByteSubclass: #ICUErrorCodeNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUErrorCodeNB class methodsFor: 'fields description' stamp: 'jvds 2/12/2012 21:53'!
fieldsDesc
	^#(
		ulong status;	" # of last request processed by server "
	)! !

!ICUErrorCodeNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:38'!
check

	self status > 0
		ifTrue: [ self error: 'ICU Error: ', self status printString ]! !

Object subclass: #ICUHandleNB
	instanceVariableNames: 'address'
	classVariableNames: ''
	poolDictionaries: 'ICUConstants'
	category: 'ICU-NativeBoost-Core'!

ICUHandleNB subclass: #ICUCalendarNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUCalendarNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:37'!
allTimeZones

	| address status |
	
	address := self primOpenTimeZones: (status := ICUErrorCodeNB new).
	status check.
	^ ICUEnumerationNB byteStringCollection: address.! !

!ICUCalendarNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 14:27'!
getDefaultTimeZone
	"self getDefaultTimeZone"
	
	| buffer1 status length |
	
	buffer1 := ByteArray new: 200.
	status := ICUErrorCodeNB new.
	
	length := self primGetDefaultTimeZone: buffer1 with: buffer1 size / 2 with: status.
	status check. 
	
	^TwoByteString fromByteArray: buffer1 charSize: length! !

!ICUCalendarNB class methodsFor: 'nbtest' stamp: 'jvds 2/24/2012 14:48'!
nbTestAllTimeZones

	| handle status |
	
	handle := self nbTestprimOpenTimeZones: (status := ICUErrorCodeNB new).
	status check.
	^ self nbTestprimNext: handle with: status ! !

!ICUCalendarNB class methodsFor: 'nbtest' stamp: 'jvds 2/24/2012 14:47'!
nbTestprimNext: aHandle with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( char* uenum_next_48( ICUEnumeration aHandle, nil, ICUErrorCodeNB* anErrorCode ) )! !

!ICUCalendarNB class methodsFor: 'nbtest' stamp: 'jvds 2/24/2012 14:50'!
nbTestprimOpenTimeZones: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( ICUEnumerationNB* ucal_openTimeZones_48( ICUErrorCodeNB* anErrorCode ) )! !

!ICUCalendarNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 14:34'!
openDefaultWithDefaultLocaleAndTimezone
	"^<UCalendar> Opens a default calendar for the default time zone - but no locale is set
	
	"
	| defaultTimezone |
	
	defaultTimezone := self getDefaultTimeZone.
	^self openDefaultWithLocale: nil timezone: defaultTimezone! !

!ICUCalendarNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 14:22'!
openDefaultWithLocale: localeString timezone: timezoneString

	| address status |
	
	address := self primOpen: timezoneString asUTF16Bytes
		with: timezoneString size
		with: localeString 
		with: 0
		with: (status := UErrorCode new).
	status check.
		
	^self newWithAddress: address! !

!ICUCalendarNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 14:26'!
primGetDefaultTimeZone: aResultBuffer with: aResultCapacity with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int ucal_getDefaultTimeZone_48( void* aResultBuffer, int aResultCapacity, ICUErrorCodeNB* anErrorCode ) )
	
! !

!ICUCalendarNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 14:38'!
primOpen: aZoneID with: aZoneIDLength with: aLocale with: aCalendarType with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void* ucal_open_48( void* aZoneID, int aZoneIDLength, char* aLocale, int aCalendarType, ICUErrorCodeNB* anErrorCode ) )! !

!ICUCalendarNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/17/2012 09:37'!
primOpenTimeZones: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void* ucal_openTimeZones_48( ICUErrorCodeNB* anErrorCode ) )! !

!ICUCalendarNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 14:28'!
dstOffset
	"^<Integer>	Field number indicating the daylight savings offset in milliseconds. "
	
	^self get: UCAL_DST_OFFSET ! !

!ICUCalendarNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 14:05'!
get: aFieldCode

	| status |
	
	status := ICUErrorCodeNB new.
	^ self primGet: aFieldCode with: status! !

!ICUCalendarNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 14:02'!
primGet: aFieldCode with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( long ucal_get_48( void* self address, long aFieldCode, ICUErrorCodeNB* anErrorCode ) )! !

!ICUCalendarNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 14:05'!
zoneOffset
	"^<Integer>	Field number indicating the daylight savings offset in milliseconds. "
	
	^self get: UCAL_ZONE_OFFSET ! !

ICUHandleNB subclass: #ICUConverterNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUConverterNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:47'!
allNames

	| enumAddress status |
		
	enumAddress := self primOpenTimeZones: (status := ICUErrorCodeNB new).
	status check.
	^ ICUEnumerationNB byteStringCollection: enumAddress 
! !

!ICUConverterNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:45'!
nbLibraryNameOrHandle

	^'libicui18n.dylib'! !

!ICUConverterNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:31'!
primOpenTimeZones: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void* ucnv_openAllNames_48( ICUErrorCodeNB* anErrorCode ) )! !

!ICUHandleNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:59'!
nbLibraryNameOrHandle

	^'libicui18n.dylib'! !

!ICUHandleNB class methodsFor: 'instance creation' stamp: 'jvds 2/24/2012 14:23'!
newWithAddress: anExternalAddress

	^ self new setAddress: anExternalAddress! !

!ICUHandleNB methodsFor: 'initialize-release' stamp: 'jvds 2/24/2012 14:23'!
setAddress: anExternalAddress

	address := anExternalAddress ! !

ICUHandleNB subclass: #ICULocaleNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICULocaleNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:03'!
collectionFromArrayOfCharPointers: arrayOfPointers

	^ Array streamContents: [ :stream |
		| index address |
		index := 0.
		[ address := NBExternalAddress value: (arrayOfPointers ulongAt: index). address isNull ] 
			whileFalse: [
				stream nextPut: address readString.
				index := index + 4 ] ]! !

!ICULocaleNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 12:44'!
isoCountries

	| arrayOfPointers|

	arrayOfPointers := self primGetISOCountries.
	^ self collectionFromArrayOfCharPointers: arrayOfPointers! !

!ICULocaleNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:00'!
isoLanguages

	| arrayOfPointers|

	arrayOfPointers := self primGetISOLanguages.
	^ self collectionFromArrayOfCharPointers: arrayOfPointers! !

!ICULocaleNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 12:29'!
nbLibraryNameOrHandle

	^'libicui18n.dylib'! !

!ICULocaleNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 12:27'!
primGetISOCountries
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void* uloc_getISOCountries_48( ) )! !

!ICULocaleNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:00'!
primGetISOLanguages
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void* uloc_getISOLanguages_48( ) )! !
